// layer.h		Suresh kumar V.Rao, H. Rao
// header file for the layer class heirarchy and
// the network class
 //#include "windows.h"                               

#define MAX_LAYERS	12
#define MAX_VECTORS	1000
#define NOISE_MARGIN 0.0001
#define INITIAL_GRADIENT 1
#define INITIAL_DELTAS  0.0001

#include <iostream>

#include "windows.h"

//#define FLOAT float
#define FLOAT_EXTRACT "%f"
#define FLOAT_PRINT "%f "



class network;
//class Kohonen_network;

/*
const __declspec(align(16)) double __expConstant[] = {1/1., 1/(2.),1/(3.),1/(4.) };
const float __expConstantln2 = (float) .6931471806;
const float __expConstantiln2 = (float)1.4426950409;
const float __expTestConstant = (float).1;


inline FLOAT squash2(FLOAT input)
{
	
if (input < -50)
	return 0.0;
else	if (input > 50)
		return 1.0;
	
	_asm {
		prefetchnta  __expConstant;

		fld1;
	///	fld1;

		fld input;
		fchs;
		fldl2e // __expConstantiln2;
		fmul st(0),st(1);
		fst st(1);

		frndint;
	
		fsub st(1), st(0);
		fxch;
		fldln2 // __expConstantln2;
		fmul;
		fld __expConstant[3*8];
		fmul;

		

		
	
		fld __expConstant[3*8];
		fmul st(0),st(1);
        fadd st(0),st(3);


		fld __expConstant[2*8];
		fmul;
		fmul st(0),st(1);

		fadd st(0),st(3);

		fld __expConstant[1*8];
		fmul;
		fmul st(0),st(1);

		fadd st(0),st(3);

	    fmul;

		fadd st(0),st(2);

		fld st(0)
		fmul 
		fld st(0)
		fmul




		fscale;
		fstp st(1);

		fadd st(0),st(1);
		fdiv;

		


	}
}
*/

const __declspec(align(16)) 
		float __expConstantMMX[] = { (float)1.0 ,(float)1.0 ,(float)1.0 ,(float)1.0,
									  (float)(0.6931471806 * 0.25*0.5) ,(float)(0.6931471806 * 0.25*0.5 ),(float)(0.6931471806 * 0.25*0.5 ),(float)(0.6931471806 * 0.25*0.5),
									  (float)(0.6931471806 * 0.25* 1/3.),(float)(0.6931471806 * 0.25*1/3.),(float)(0.6931471806 * 0.25*1/3.),(float)(0.6931471806 * 0.25*1/3.),
									  (float)(0.6931471806 * 0.25*0.25),(float)(0.6931471806 * 0.25*0.25),(float)(0.6931471806 * 0.25*0.25),(float)(0.6931471806 * 0.25*0.25)};
const __declspec(align(16))  float __expConstantln2MMX[] = {
						 (float)(.6931471806 * 0.25) ,(float)(.6931471806* 0.25) ,(float)(0.6931471806 * 0.25),(float)(0.6931471806 * 0.25) ,
						 (float)-1.4426950409, (float)-1.4426950409,(float)-1.4426950409,(float)-1.4426950409 };
/*const __declspec(align(16))  __int32 __expConstantEEMMX[] = {
		0x3F800000,0x3F800000,0x3F800000,0x3F800000	 };*/
const __declspec(align(16)) float __expConstantEEMMX[] = {
	 1,1,1,1};
	
						 
/*
const __declspec(align(16))  float __expConstantiln2 = 1.4426950409;
const __declspec(align(16))  float __expTestConstant = .1;
*/

inline __declspec(naked) void squashXMM(FLOAT *input)
{
	/*
if (input < -50)
	return 0.0;
else	if (input > 50)
		return 1.0;*/
	static __declspec(align(16)) float temp[4];

	
	_asm {


	
		prefetchnta  [__expConstantln2MMX];
		prefetchnta  [__expConstantMMX];
		prefetchnta  [__expConstantMMX + 32];
		prefetchnta  [__expConstantEEMMX];

	/*	mov eax, [esp+4];
		movups xmm1, [eax];
		movaps xmm2, xmm1;
		movaps xmm3, xmm1;
		movaps xmm4, [__expConstantEEMMX + 2*4];
		movaps xmm5, [__expConstantEEMMX + 1*4];
		cmpnltps xmm2,xmm4;
		cmpltps  xmm3,xmm5;
		andps xmm4, xmm2;
		andps xmm5, xmm3;

		andps xmm2, xmm3;
		*/


				


		mov eax,[esp+4];
		movups xmm1, [eax];
		mulps xmm1, [__expConstantln2MMX + 4*4];

		movhlps xmm0, xmm1;

		cvtps2pi mm0, xmm1;
		cvtps2pi mm1, xmm0;


		cvtpi2ps  xmm4, mm0;
		cvtpi2ps  xmm5, mm1;
		movlhps xmm4, xmm5;


/*
		cvtps2dq xmm3,xmm4;
		cvtdq2ps xmm4, xmm3;
*/

		subps xmm1, xmm4;
		movaps xmm0, xmm1; 
		movaps xmm2, xmm1; 
		movaps xmm4, xmm1;

	//	movaps xmm3,xmm4;

		pslld mm0, 23;
		pslld mm1, 23;
		paddd mm0, [__expConstantEEMMX];
		paddd mm1, [__expConstantEEMMX];

				
		movq [temp], mm0;
		movq [temp+8], mm1;

		
		//movd

		movaps xmm3, [temp];

		


		//paddd xmm3, [__expConstantEEMMX];  /* xmm3 = 2^xmm3 */
		
	


		movaps xmm7, [__expConstantMMX] ; /* xmm7 =1 */

		mulps xmm1, [__expConstantln2MMX]; /* xmm1 = x/4 */
		mulps xmm2, [__expConstantMMX  + 2*4*4];   /* xmm2 = (x/4)/3 */
		mulps xmm4, [__expConstantMMX  + 1*4*4];   /* xmm4 = (x/4)/2 */
		mulps xmm0, [__expConstantMMX  + 3*4*4];   /* xmm0 = (x/4)/4 */

		/* exp(x) = 1 + x + x^2/2 + x^3/6 + x^4/24 */
		/* exp(x) = 1 + x(1 + (x/2)(1 + (x/3)(1+ x/4)))*/


		addps xmm0, xmm7;
		mulps xmm0, xmm2;
		addps xmm0, xmm7;
		mulps xmm0, xmm4;
		addps xmm0, xmm7;
		mulps xmm0, xmm1;
		addps xmm0, xmm7;

		mulps xmm0, xmm0;
		mulps xmm0, xmm0;

		mulps xmm0, xmm3;
		addps xmm0, xmm7;
		divps xmm7, xmm0;

		movups [eax], xmm7;
		ret;

	}
}




inline FLOAT squash(FLOAT input)
// squashing function
// use sigmoid -- can customize to something
// else if desired; can add a bias term too
//
{
	
if (input < -50)
	return 0.0;
else	if (input > 50)
		return 1.0;

 return (FLOAT) 1/(1+ exp((double) -input));



 // FLOAT ret = (FLOAT)  (1/(1+cal));

  //return (FLOAT) cal; //1/(1+exp(-(double)input));
       

}

#pragma pack(push, 4)


struct NeuralNetLayerInfo {
	__int32 num_inputs;
	__int32 num_outputs;
	FLOAT *outputs;
	FLOAT *inputs;
	FLOAT *orig_outputs;
	FLOAT *weights;
	FLOAT *output_errors; // array of errors at output
	FLOAT *back_errors; // array of errors back-propagated
	FLOAT *expected_values;	// to inputs
	FLOAT *past_gradients;	// for momentum
	FLOAT *past_deltas;	// for momentum
	FLOAT *alloc_outputs;
	FLOAT *alloc_inputs;
	FLOAT *alloc_orig_outputs;
	FLOAT *alloc_weights;
	FLOAT *alloc_output_errors; // array of errors at output
	FLOAT *alloc_back_errors; // array of errors back-propagated
	FLOAT *alloc_expected_values;	// to inputs
	FLOAT *alloc_past_gradients;	// for momentum
	FLOAT *alloc_past_deltas;	// for momentum



	__int32  num_roundedoutputs;  // to the nearest 4
    bool __stdcall CalcOut(__int32 bMakeCheck);
	void __stdcall UpdateWeights(FLOAT beta);
	void __stdcall CalculateError();
	inline FLOAT * Getweights(int iRowLocation = 0) {
		return &weights[iRowLocation * num_roundedoutputs];
	}

	typedef FLOAT GENETYPE;

	inline int GeneLength()  const {
		  return num_inputs*num_roundedoutputs;
	}

	inline GENETYPE* GetGenes() {
		return &weights[0];
	}
	inline bool GeneRecurseIn() const {
		return false;
	}


};

#pragma pack(pop, 4)


class layer: protected NeuralNetLayerInfo 
{               
   
protected:





	friend network;
	//friend Kohonen_network; // update for Kohonen model
	
public:
                     
	//void calc_out();
};

	

class input_layer: public layer
{

private:

FLOAT noise_factor;


public:
	                        
	input_layer(int, int);
	~input_layer();
	void calc_out();
	void set_NF(FLOAT);
	
	friend network;	
};

class middle_layer;

class output_layer:	public layer
{
protected:
	int m_rndint;
	
	
    friend network;
    
public:
	                        
	               
	output_layer(int, int);
	~output_layer();    

	void calc_error(FLOAT &);
	void randomize_weights();
	inline void update_weights(const FLOAT beta, const FLOAT) {
		NeuralNetLayerInfo::UpdateWeights(beta);
	}
	void update_momentum();



	void list_weights();
	void write_weights(int, FILE *);
	void read_weights(int, FILE *);
	void list_errors();
	void list_outputs();

	inline void calc_out()
{                            

    if(!NeuralNetLayerInfo::CalcOut(m_rndint++ % 8)) {

	cout << "weights are blowing up\n";
			cout << "try a smaller learning constant\n";
			cout << "e.g. beta=0.02    aborting...\n";
			exit(1);
	}

}            




};


	

class middle_layer:	public output_layer
{

private:

public:
    middle_layer(int, int);
    ~middle_layer();
void middle_layer::calc_error()
{        
NeuralNetLayerInfo::CalculateError() ;
 return;
}

};	

class FileBuffer {
	FLOAT *buffer;
	fpos_t position;
	int fill_IObuffer(FILE *);
};


class network        

{



private:

	layer *layer_ptr[MAX_LAYERS];
    int number_of_layers;
    int layer_size[MAX_LAYERS];
    FLOAT *buffer;
    fpos_t position;
    unsigned training;

	FileBuffer pFileInput;



 
public:
    network();
    ~network();
	void set_training(const unsigned &);
	unsigned get_training_value();
	void get_layer_info();
	void set_up_network();
	void randomize_weights();
	void update_weights(const FLOAT, const FLOAT);
	void update_momentum();
	void write_weights(FILE *);
	void read_weights(FILE *);     
	void list_weights();
	void write_outputs(FILE *);
	void list_outputs();
	void list_errors();
	void forward_prop();
	void backward_prop(FLOAT &);
	int fill_IObuffer(FILE *);
	void set_up_pattern(int);
	void set_NF(FLOAT);


	
};	    
    


